/*
Module : PJNFINGER.H
Purpose: Defines the interface for a MFC class encapsulation of the Finger protocol
Created: PJN / 11-10-1999

Copyright (c) 1999 - 2006 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


/////////////////////////////// Macros / Defines //////////////////////////////

#pragma once

#ifndef __PJNFINGER_H__
#define __PJNFINGER_H__

#ifndef _WINSOCKAPI_
#pragma message("To avoid this message, put afxsock.h or winsock.h in your PCH (usually stdafx.h)")
#include <winsock.h>
#endif

#ifndef __AFXPRIV_H__
#pragma message("To avoid this message, put afxpriv.h in your PCH (usually stdafx.h)")
#include <afxpriv.h>
#endif

#include "SocMFC.h" //If you get a compilation error about this missing header file, then you need to download my CWSocket wrapper classes from http://www.naughter.com/w3mfc.html

#ifndef CPJNFINGER_EXT_CLASS
#define CPJNFINGER_EXT_CLASS
#endif
  

/////////////////////////////// Classes ///////////////////////////////////////

//The main class which encapsulates the Finger protocol
class CPJNFINGER_EXT_CLASS CPJNFinger
{
public:
  typedef enum ProxyType
  {
    ptNone = 0,
    ptSocks4 = 1,
    ptSocks5 = 2,
    ptHTTP = 3
  };

//Constructors / Destructors
  CPJNFinger();

//Methods
  BOOL Finger(LPCTSTR pszHostName, LPCTSTR pszUser, CString& sReply, BOOL bVerbose=TRUE, int nPort=79);

  DWORD     GetTimeout() const { return m_dwTimeout; };
  void      SetTimeout(DWORD dwTimeout) { m_dwTimeout = dwTimeout; };
  void      SetProxyType(ProxyType proxyType) { m_ProxyType = proxyType; };
  ProxyType GetProxyType() const { return m_ProxyType; };
  void      SetProxyServer(const CString& sServer) { m_sProxyServer = sServer; };
  CString   GetProxyServer() const { return m_sProxyServer; };
  void      SetProxyPort(int nPort) { m_nProxyPort = nPort; };
  int       GetProxyPort() { return m_nProxyPort; };
  void      SetBoundAddress(const CString& sLocalBoundAddress) { m_sLocalBoundAddress = sLocalBoundAddress; };
  CString   SetBoundAddress() const { return m_sLocalBoundAddress; };
  void      SetProxyUserName(const CString& sUserName) { m_sProxyUserName = sUserName; };
  CString   GetProxyUserName() const { return m_sProxyUserName; };
  void      SetProxyPassword(const CString& sPassword) { m_sProxyPassword = sPassword; };
  CString   GetProxyPassword() const { return m_sProxyPassword; };
  CString   GetHTTPProxyUserAgent() const { return m_sUserAgent; };
  void      SetHTTPProxyUserAgent(const CString& sUserAgent) { m_sUserAgent = sUserAgent; };
  DWORD     GetLastError() const { return m_dwLastError; };

protected:
//Methods
  BOOL ReadResponse(CWSocket& f, LPSTR pszBuffer, int nInitialBufSize, 
                    LPSTR* ppszOverFlowBuffer, DWORD dwTimeout, int nGrowBy=4096);

//Member variables
  ProxyType m_ProxyType;
  CString   m_sProxyServer;
  int       m_nProxyPort;
  CString   m_sLocalBoundAddress;
  CString   m_sProxyUserName;
  CString   m_sProxyPassword;
  CString   m_sUserAgent;
	DWORD     m_dwTimeout;
	DWORD     m_dwLastError;
};

#endif //__PJNFINGER_H__
