#include "stdafx.h"
#include "WinFinger.h"
#include "WinFingerDoc.h"
#include "PJNFinger.h"
#include "HostDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CWinFingerDoc, CDocument)

BEGIN_MESSAGE_MAP(CWinFingerDoc, CDocument)
	//{{AFX_MSG_MAP(CWinFingerDoc)
	ON_COMMAND(ID_FILE_CONNECT, OnFileConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CWinFingerDoc::CWinFingerDoc()
{
}

CWinFingerDoc::~CWinFingerDoc()
{
}

#ifdef _DEBUG
void CWinFingerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CWinFingerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


void CWinFingerDoc::OnFileConnect() 
{
  //Bring up the host dialog
  CHostDlg dlg;
  if (dlg.DoModal() == IDOK)
  {
    //Display the hour glass
    CWaitCursor wait;

    //The main class which encapsulates the Finger protocol
    CPJNFinger f;
    CString sReply;
    BOOL bSuccess = f.Finger(dlg.m_sHost, dlg.m_sUser, sReply, dlg.m_bVerbose);

    //Display a message box if any errors occurs
    if (!bSuccess)
    {
      CString sError;
      sError.Format(_T("%d"), f.GetLastError());

      CString sMsg;
      AfxFormatString2(sMsg, IDS_FINGER_ERROR, dlg.m_sHost, sError);
      (static_cast<CEditView*>(m_viewList.GetHead()))->SetWindowText(sMsg);
    }
    else
    {
      //Set the text in the edit control
	    (static_cast<CEditView*>(m_viewList.GetHead()))->SetWindowText(sReply);
    }
  }
}
